<?php

/*   mnoGoSearch-php v.3.2.7
 *   for mnoGoSearch ( formely known as UdmSearch ) free web search engine
 *   (C) 2001 by Sergey Kartashoff <gluke@mail.ru>,
 *               mnoGoSearch Developers Team <devel@mnogosearch.org>
 */

if (!extension_loaded('mnogosearch')) {
	print "<b>This script requires PHP4.3.0+ with mnoGoSearch extension</b>";
	exit;
}

define("UDM_ENABLED",1);
define("UDM_DISABLED",0);

require('config.inc');
require('common.inc');
require('template.inc');

require('init.inc');

if ($lang_content_negotiation == 'yes') {
// path to template file ($lang_content_negotiation = 'yes')
// please refer to docs on this feature before using it.
	$template_file= preg_replace("/\.php\.*/", ".htm", basename($SCRIPT_FILENAME));
	$template_file = "./" . $template_file;
} else {
// path to template file ($lang_content_negotiation = 'no')
	$template_file='search.htm';
}

// -----------------------------------------------
//  M A I N 
// -----------------------------------------------


if (!$cc) {
    init();

    if (! $have_query_flag) {
	print_template('bottom');
        return;	
    } elseif ($have_query_flag && ($q=='')) {
        print_template('noquery'); 	
        print_template('bottom');
        return;
    }         

    $res=Udm_Find($udm_agent,$q);

    if(!$res){
    	    print_error_local(Udm_Error($udm_agent));	
    } else {	
    	$found=Udm_Get_Res_Param($res,UDM_PARAM_FOUND);
        $rows=Udm_Get_Res_Param($res,UDM_PARAM_NUM_ROWS);
        $wordinfo=Udm_Get_Res_Param($res,UDM_PARAM_WORDINFO_ALL);
	$searchtime=Udm_Get_Res_Param($res,UDM_PARAM_SEARCHTIME);
	$first_doc=Udm_Get_Res_Param($res,UDM_PARAM_FIRST_DOC);
	$last_doc=Udm_Get_Res_Param($res,UDM_PARAM_LAST_DOC);

        if (!$found) {
    		print_template('notfound');
    		print_template('bottom');
    		return;
	} 

        $from=IntVal($np)*IntVal($ps); 
	$to=IntVal($np+1)*IntVal($ps); 

	if($to>$found) $to=$found;
	if (($from+$ps)<$found) $isnext=1;
	$nav=make_nav($query_orig);

        print_template('restop');

	$global_doc_res=$res;

        for($i=0;$i<$rows;$i+=1){
        	$excerpt_flag=0;
        	$clonestr='';

        	$rec_id=Udm_Get_Res_Field($res,$i,UDM_FIELD_URLID);
		
		$global_res_position=$i;

        	if (Udm_Api_Version() >= 30207) {
			$origin_id=Udm_Get_Res_Field($res,$i,UDM_FIELD_ORIGINID);
			if ($origin_id) continue;
			else {
				for($j=0;$j<$rows;$j+=1){
					$cl_origin_id=Udm_Get_Res_Field($res,$j,UDM_FIELD_ORIGINID);
					if (($cl_origin_id) &&
					    ($cl_origin_id == $rec_id)) {
						$url=Udm_Get_Res_Field($res,$j,UDM_FIELD_URL);
                				$contype=Udm_Get_Res_Field($res,$j,UDM_FIELD_CONTENT);
  						$docsize=Udm_Get_Res_Field($res,$j,UDM_FIELD_SIZE);
  						$lastmod=format_lastmod(Udm_Get_Res_Field($res,$j,UDM_FIELD_MODIFIED));
						if (Udm_Api_Version() >= 30207) {
						    $pop_rank=Udm_Get_Res_Field($res,$i,UDM_FIELD_POP_RANK);
						} else $pop_rank='';
  						$clonestr.=print_template('clone',0)."\n";
					}
				}
			}
		} 
		
        	if (Udm_Api_Version() >= 30204) {
       			$excerpt_flag=Udm_Make_Excerpt($udm_agent, $res, $i);
        	}

		$ndoc=Udm_Get_Res_Field($res,$i,UDM_FIELD_ORDER);
		$rating=Udm_Get_Res_Field($res,$i,UDM_FIELD_RATING);
                $url=Udm_Get_Res_Field($res,$i,UDM_FIELD_URL);
                $contype=Udm_Get_Res_Field($res,$i,UDM_FIELD_CONTENT);
  		$docsize=Udm_Get_Res_Field($res,$i,UDM_FIELD_SIZE);
  		$lastmod=format_lastmod(Udm_Get_Res_Field($res,$i,UDM_FIELD_MODIFIED));

        	$title=Udm_Get_Res_Field($res,$i,UDM_FIELD_TITLE);   
  		$title=($title) ? htmlspecialChars($title):basename($url);

  		$title=ParseDocText($title);
  		$text=ParseDocText(htmlspecialChars(Udm_Get_Res_Field($res,$i,UDM_FIELD_TEXT)));
		//$text=ParseDocText(htmlspecialChars(Udm_Get_Res_Field_ex($res,$i,"Body")));
                $keyw=ParseDocText(htmlspecialChars(Udm_Get_Res_Field($res,$i,UDM_FIELD_KEYWORDS)));
  		$desc=ParseDocText(htmlspecialChars(Udm_Get_Res_Field($res,$i,UDM_FIELD_DESC)));
  		
  		$crc=Udm_Get_Res_Field($res,$i,UDM_FIELD_CRC);  		
		
		if (Udm_Api_Version() >= 30203) {
		    $doclang=Udm_Get_Res_Field($res,$i,UDM_FIELD_LANG);
		    $doccharset=Udm_Get_Res_Field($res,$i,UDM_FIELD_CHARSET);
		}

  		if ($phpver >= 40006) {
  			$category=Udm_Get_Res_Field($res,$i,UDM_FIELD_CATEGORY);
  		} else {
  			$category='';
  		}

  		reset($alias_arr);
  		$save_url=$url;
  		while(list($t_alias,$t_url)=each($alias_arr)) {
  			$url=preg_replace("/^$t_alias/i",$t_url,$url);
  		}

		if (Udm_Api_Version() <= 30223) {
		    if (Udm_Api_Version() >= 30204) {
			if ($excerpt_flag) {
				if (Udm_Api_Version() >= 30216) {
				    if (Udm_Get_Res_Field_Ex($res,$i,"CachedCopy")!='') {
					$stored_href="$self?cc=1".
	    				     "&url=".urlencode($save_url).
	    				     "&q=".urlencode($query_orig);
				    }
				} elseif (Udm_Api_Version() >= 30211) {
					$stored_href="$storedocurl?rec_id=".Udm_Hash32($udm_agent,$save_url).
            				     "&DM=".urlencode($lastmod).
	    				     "&DS=$docsize".
	    				     "&L=$doclang".
	    				     "&CS=$doccharset".
	    				     "&DU=".urlencode($save_url).
	    				     "&CT=".urlencode($contype).
	    				     "&q=".urlencode($query_orig);
				} else {
					$stored_href="$storedocurl?rec_id=".Udm_CRC32($udm_agent,$save_url).
            				     "&DM=".urlencode($lastmod).
	    				     "&DS=$docsize".
	    				     "&L=$doclang".
	    				     "&CS=$doccharset".
	    				     "&DU=".urlencode($save_url).
	    				     "&CT=".urlencode($contype).
	    				     "&q=".urlencode($query_orig);
	    			}
				if ($stored_href!='') $storedstr=print_template('stored',0);
			} else $storedstr='';
		    } else $storedstr='';
		} else {
		    if (Udm_Get_Res_Field_Ex($res,$i,"CachedCopy")!='') {
			if (Udm_Get_Res_Field_Ex($res,$i,"dbnum")=='') {
			    $stored_href="$self?cc=1".
	    			     "&url=".urlencode($save_url).
	    			     "&q=".urlencode($query_orig);
			} else {
			    $stored_href="$self?cc=1".
			             "&dbnum=".Udm_Get_Res_Field_Ex($res,$i,"dbnum").
	    			     "&url=".urlencode($save_url).
	    			     "&q=".urlencode($query_orig);
			}
			$storedstr=print_template('stored',0);
		    }
		}

		$sitelimitstr=$persite='';
		if ((Udm_Api_Version() >= 30207) &&
		    ($groupbysite == 'yes')) {
		    if (!$site) {
			$sitelimit_href="$PHP_SELF?$QUERY_STRING"; 
			$sitelimit_href=preg_replace("/\&np=\d*/",'',$sitelimit_href);
			$sitelimit_href.="&np=0&site=".Udm_Get_Res_Field($res,$i,UDM_FIELD_SITEID);
			$persite=Udm_Get_Res_Field_Ex($res,$i,"PerSite");
			$sitelimitstr=print_template('site_limit',0);
		    }
		}
		

		if (Udm_Api_Version() >= 30207) {
			$pop_rank=Udm_Get_Res_Field($res,$i,UDM_FIELD_POP_RANK);
		} else $pop_rank='';

		
  		if ((substr($url,0,6)=="ftp://") && 
      	    	    ($templates['ftpres'][0] != '')) {
			print_template('ftpres');
  		} elseif (((substr($url,0,7)=="http://")||(substr($url,0,8)=="https://")) && 
            	    ($templates['httpres'][0] != '')) {
			print_template('httpres');
  		} else {
			print_template('res');
  		}
	}	
	$global_doc_res='';
	
        print_template('resbot');    
	print_template('bottom');

        // Free result
	Udm_Free_Res($res);
    }
} else {
    /* show cached copy */
    init_cc();
    $res=udm_store_doc_cgi($udm_agent);
    
    $id=udm_get_agent_param_ex($udm_agent,'ID');
    $last_modified=udm_get_agent_param_ex($udm_agent,'Last-Modified');
    $content=udm_get_agent_param_ex($udm_agent,'Content-Type');
    $length=udm_get_agent_param_ex($udm_agent,'Content-Length');
    $charset=udm_get_agent_param_ex($udm_agent,'Charset');
    
    Header ("Content-Type: text/html; charset=$charset");
    
    print_template('storedoc_top');
    
    if ($res) {
	$document=ParseDocText(udm_get_agent_param_ex($udm_agent,'document'));
	print_template('storedoc');
    }
    
    print_template('storedoc_bottom');
}

    if ($have_spell_flag) Udm_Free_Ispell_Data($udm_agent);
    Udm_Free_Agent($udm_agent);
?>
